/*
 * Soubor:  find.c
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Zdrojov sbor vstavanej vyhadvacej funkcie find() 
 *          - Knuth-Moris-Prattov algoritmus
 */

#include "find.h"


void pre(char** vzor, int dlzka, int *postupnost)
{
     int i = 0;
     int j = postupnost[0] = -1;
     
     while(i < dlzka)
     {
             while(j > -1 && (*vzor)[i] != (*vzor)[j]) j = postupnost[j];
             i++; j++;
             if((*vzor)[i] == (*vzor)[j])
             {
                        postupnost[i] = postupnost[j];
                        }
                        else
                        {
                            postupnost[i] = j;
                        }
     }
 }
 
int NAJDI_KMP(char** retazec, int velkost_r, char** vzor, int velkost_v)
{
    int MAX_DLZKA_VZORKU = velkost_r;
    int j;
    int i;
    int postupnost[MAX_DLZKA_VZORKU + 1];
    pre(vzor, velkost_v, &postupnost[0]);
    
    i = 0;
    j = 0;
    
    while( j < velkost_r)
    {
           if((*vzor)[i] == (*retazec)[j])
           {
                      if(i == (velkost_v - 1))
                      {
                           return (j - velkost_v + 1);
                       }
                       else 
                       {
                            i++;
                            j++;
                        }
           }
           else if(postupnost[i] == -1)
           {
                            i = 0;
                            j++;
           }
           else
           {
               i = postupnost[i];
           }
    }
    return -1;
    
}



