/*
 * Soubor:  hash.h
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Hashovac tabulka - knihovna
 */

#ifndef _HASH_H_
#define _HASH_H_

#include <stdlib.h>
#include <string.h>

#define HASHTAB_SIZE 4096
#define CONSTLENGHT 7
#define UNDEFINED -1

typedef union Thodnota                       // union pro hodnotu konstanty
{
  int int_cislo;
  double double_cislo;
  char *retezec;
}thodnota;

typedef struct htable_prvek             // poloka hashovacej tabuky
{
  char *jmeno;                              // jej nzev
  int typ;                                  // typ poloky
  thodnota hodnota;
  struct htable_prvek *dalsi;
}tprvek;

typedef struct htable_t                    //Samotn hashovac tabulka
{
  int size;
  tprvek **pole;
}thtab;

thtab *htab_init();                                          // inicializace hashovac tabulky

unsigned int hash_function(const char *, unsigned );             // hashovac fuknce

tprvek *htable_lookup (thtab *, char *, char *, int);       // vyhledn nebo vloeni poloky do tabulky

void htab_dispose (thtab *);                                    // uvolnn cel tabulky

void htab_delete (thtab *);                                   // vymazn vech poloek

#endif /* _HASH_H_ */
