/*
 * Soubor:  interpret.c
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Zdrojov sbor interpretra
 */


#include "interpret.h"

//ERROR funkce dokoncit

int interpret(torderlist *list) {


  torderPtr *order = active_list(list);

  while ((*order) != NULL) {

    switch ((*order)->operation) {


    case CIN_INTEGER:
      cin_integer((*order)->uk3);
      break;

    case CIN_DOUBLE:
      cin_double((*order)->uk3);
      break;

    case CIN_STRING:
      cin_string((*order)->uk3);
      break;

    case COUT_INTEGER:
      cout_integer((*order)->uk3);
      break;

    case COUT_DOUBLE:
      cout_double((*order)->uk3);
      break;

    case COUT_STRING:
      cout_string((*order)->uk3);
      break;

    case NOT:
      not_fce((*order)->uk1, (*order)->uk3);
      break;

//////////////////////////////////////////////////////////////////////////////////////

    case GOTO:
      // instrukce pro provedeni nepodmineneho skoku
      goto_fce(order, (*order)->uk3);
      continue;

    case GOTO_CONDITION:
      // instrukce skoku pro provedeni podmineneho skoku
      goto_condition(order, (*order)->uk1, (*order)->uk3, list);
      continue;

//////////////////////////////////////////////////////////////////////////////////////

    case ADD_INTEGER:
      add_integer((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case SUB_INTEGER:
      sub_integer((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case MUL_INTEGER:
      mull_integer((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case DIV_INTEGER:
      div_integer((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case ADD_DOUBLE:
      add_double((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case SUB_DOUBLE:
      sub_double((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case MUL_DOUBLE:
      mull_double((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case DIV_DOUBLE:
      div_double((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case LESS_INTEGER:
      less_integer((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case LESS_DOUBLE:
      less_double((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

     case LESS_STRING:
      less_string((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case ABOVE_INTEGER:
      above_integer((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case ABOVE_DOUBLE:
      above_double((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case ABOVE_STRING:
      above_string((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case LESSOREQUAL_INT:
      lessorequal_int((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case LESSOREQUAL_DOUBLE:
      lessorequal_double((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case LESSOREQUAL_STRING:
      lessorequal_string((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case ABOVEQUAL_INTEGER:
      abovequal_integer((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case ABOVEQUAL_DOUBLE:
      abovequal_double((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case ABOVEQUAL_STRING:
      abovequal_string((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case EQUAL_INTEGER:
      equal_integer((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case EQUAL_DOUBLE:
      equal_double((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case EQUAL_STRING:
      equal_string((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case NOT_EQUAL_INTEGER:
      not_equal_integer((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case NOT_EQUAL_DOUBLE:
      not_equal_double((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case NOT_EQUAL_STRING:
      not_equal_string((*order)->uk1, (*order)->uk2, (*order)->uk3);
      break;

    case PRIRADENIE_INTEGER:
      priradenie_integer((*order)->uk1, (*order)->uk3);
      break;

    case PRIRADENIE_DOUBLE:
      priradenie_double((*order)->uk1, (*order)->uk3);
      break;

    case PRIRADENIE_STRING:
      priradenie_double((*order)->uk1, (*order)->uk3);
      break;

    case RETYPE_INT_TO_REAL:
      retype_int_to_real((*order)->uk1);
      break;

    case RETURN_INT:
      return_int((*order)->uk3);
      break;

    case LENGHT_STRING:
      lenght_string((*order)->uk1, (*order)->uk3);
      break;

    case SORT_STRING:
      sort_string((*order)->uk3);
      break;
      
    default: break;
}

    order = active_list(list);

    if(error != ERR_EOK) {
      return FALSE;
    }

  }

  return ERR_EOK;

}


void cin_integer(tprvek *item)
{
  // instrukce pro nacteni hodnoty ze std. vstupu
  int vstup_int = scanf("%d", &(item->hodnota.int_cislo));
  if (vstup_int == 0) {
    error = ERR_INT;
  }
}

void cin_double(tprvek *item)
{
  // instrukce pro nacteni hodnoty ze std. vstupu
  int vstup_double = scanf("%lf", &(item->hodnota.double_cislo));
  if (vstup_double == 0) {
    error = ERR_INT;
  }
}

void cin_string(tprvek *item)
{
  string str = str_init();
  int ret;
  ret = 0;

  if (item->hodnota.retezec != NULL) {
    free(item->hodnota.retezec);
  }

  while (((ret = getc(stdin)) != '\n') && (ret != EOF)) {
    add_char(&str, ret);
  }

  item->hodnota.retezec = strGetStr(&str);

}

void cout_integer(tprvek *item)
{
  //instrukce pro vypis hodnoty na std. vystup
  printf("%d", item->hodnota.int_cislo);
}

void cout_double(tprvek *item)
{
  //instrukce pro vypis hodnoty na std. vystup
  //pro lepsi citelnost za kazdou vypsanou hodnotu je vlozen znak konce radku
  printf("%f", item->hodnota.double_cislo);
//printf("%f\n", ((tprvek*)I->poloz3)->hodnota.double_cislo);
}

void cout_string(tprvek *item)
{
  //instrukce pro vypis hodnoty na std. vystup
  //pro lepsi citelnost za kazdou vypsanou hodnotu je vlozen znak konce radku
  printf("%s", item->hodnota.retezec);
}

void not_fce(tprvek *poloz1, tprvek *poloz2)
{
  // instrukce pro negaci (0 -> 1, cokoliv krome 0 -> 0)
  if (poloz1->hodnota.int_cislo == 0) {
    poloz2->hodnota.int_cislo = 1;
  }
  else {
    poloz2->hodnota.int_cislo = 0;
  }
}

void goto_fce(torderPtr *next_order, tprvek *item)
{
  *next_order = (torderPtr)item;
}

void goto_condition(torderPtr *next_order, tprvek *cond, tprvek *item, torderlist *list)
{
  if (cond->hodnota.int_cislo == 0) {
    next_order = (torderPtr *)active_list(list);
  }
  else {
    *next_order = (torderPtr)item;
  }
}

void add_integer(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{

    poloz3->hodnota.int_cislo = poloz1->hodnota.int_cislo + poloz2->hodnota.int_cislo;

}

void sub_integer(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{

    poloz3->hodnota.int_cislo = poloz1->hodnota.int_cislo - poloz2->hodnota.int_cislo;
    
}

void mull_integer(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
 
    poloz3->hodnota.int_cislo = poloz1->hodnota.int_cislo * poloz2->hodnota.int_cislo;


}

void div_integer(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if ((poloz2->hodnota.int_cislo) == 0) {
    error = ERR_INT;
  }
  else {
    poloz3->hodnota.int_cislo = poloz1->hodnota.int_cislo / poloz2->hodnota.int_cislo;
  }
}

void add_double(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  poloz3->hodnota.double_cislo = poloz1->hodnota.double_cislo + poloz2->hodnota.double_cislo;
}

void sub_double(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  poloz3->hodnota.double_cislo = poloz1->hodnota.double_cislo - poloz2->hodnota.double_cislo;
}

void mull_double(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  poloz3->hodnota.double_cislo = poloz1->hodnota.double_cislo * poloz2->hodnota.double_cislo;
}

void div_double(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if ((poloz2->hodnota.double_cislo) == 0) {
    error = ERR_INT;
  }
  else {
    poloz3->hodnota.double_cislo = poloz1->hodnota.double_cislo / poloz2->hodnota.double_cislo;
  }
}

void less_integer(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.int_cislo < poloz2->hodnota.int_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void less_double(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.double_cislo < poloz2->hodnota.double_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void less_string(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (strcmp(poloz1->hodnota.retezec, poloz2->hodnota.retezec) < 0) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void above_integer(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.int_cislo > poloz2->hodnota.int_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void above_double(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.double_cislo > poloz2->hodnota.double_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void above_string(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (strcmp(poloz1->hodnota.retezec, poloz2->hodnota.retezec) > 0) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void lessorequal_int(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.int_cislo <= poloz2->hodnota.int_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void lessorequal_double(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.double_cislo <= poloz2->hodnota.double_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void lessorequal_string(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (strcmp(poloz1->hodnota.retezec, poloz2->hodnota.retezec) <= 0) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void abovequal_integer(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.int_cislo >= poloz2->hodnota.int_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void abovequal_double(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.double_cislo >= poloz2->hodnota.double_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void abovequal_string(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (strcmp(poloz1->hodnota.retezec, poloz2->hodnota.retezec) >= 0) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void equal_integer(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.int_cislo == poloz2->hodnota.int_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void equal_double(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.double_cislo == poloz2->hodnota.double_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void equal_string(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (strcmp(poloz1->hodnota.retezec, poloz2->hodnota.retezec) == 0) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void not_equal_integer(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.int_cislo != poloz2->hodnota.int_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void not_equal_double(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (poloz1->hodnota.double_cislo != poloz2->hodnota.double_cislo) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void not_equal_string(tprvek *poloz1, tprvek *poloz2, tprvek *poloz3)
{
  if (strcmp(poloz1->hodnota.retezec, poloz2->hodnota.retezec) != 0) {
    poloz3->hodnota.int_cislo = TRUE;
  }
  else {
    poloz3->hodnota.int_cislo = FALSE;
  }
}

void priradenie_integer(tprvek *poloz1, tprvek *poloz3)
{
  poloz3->hodnota.int_cislo = poloz1->hodnota.int_cislo;
  
}

void priradenie_double(tprvek *poloz1, tprvek *poloz3)
{
  poloz3->hodnota.double_cislo = poloz1->hodnota.double_cislo;

}

void priradenie_string(tprvek *poloz1, tprvek *poloz3)
{
  string zdroj;
  if (poloz3->hodnota.retezec == NULL) {
    zdroj = str_init();
  }
  else {
    zdroj.text = poloz3->hodnota.retezec;
    zdroj.lenght = strlen(poloz3->hodnota.retezec);
    zdroj.allocSize = zdroj.lenght + 1;
  }
  str_copy_string(&zdroj, poloz1->hodnota.retezec);
  poloz3->hodnota.retezec = strGetStr(&zdroj);

  //str_copy( &((poloz3)->hodnota.retezec), &((poloz1)->hodnota.retezec));
}

void retype_int_to_real(tprvek *item)
{
  double pomocna = item->hodnota.int_cislo;
  item->hodnota.double_cislo = pomocna;
  item->typ = N_DOUBLE;
}


int return_int(tprvek *poloz3)
{
  return poloz3->hodnota.int_cislo;
}

/////////////////////////////////////////////////////////////////////
void lenght_string(tprvek *poloz1, tprvek *poloz3)
{
     if(poloz1->hodnota.retezec == NULL)
     {
                                error = ERR_INT;
                                }
                                else
                                {
  poloz3->hodnota.int_cislo = strlen(poloz1->hodnota.retezec);
}
}

void sort_string(tprvek *poloz3)
{
     int i;
     i = strlen(poloz3->hodnota.retezec);
     heap_sort(&(poloz3->hodnota.retezec),i);

}

 //vylepsit
void concat_string(tprvek *poloz1, tprvek *poloz2 , tprvek *poloz3)
{
     string str_ciel;
     if(poloz3->hodnota.retezec == NULL)
     {                         
     str_ciel = str_init();
     }
     else
     {
     str_ciel.text = poloz1->hodnota.retezec;
     str_ciel.lenght = strlen(poloz1->hodnota.retezec);
     str_ciel.allocSize = str_ciel.lenght + 1;
     }
     str_copy_string(&str_ciel,poloz1->hodnota.retezec);
     str_scitanie_string(&str_ciel,poloz2->hodnota.retezec);
     poloz3->hodnota.retezec = strGetStr(&str_ciel);
}

void find_str(tprvek *poloz1 ,tprvek *poloz2 ,tprvek *poloz3)
{
     int i;
     int j;
     i = strlen(poloz1->hodnota.retezec);
     j = strlen(poloz2->hodnota.retezec);
     
     poloz3->hodnota.int_cislo = NAJDI_KMP(&(poloz1->hodnota.retezec),i,&(poloz2->hodnota.retezec),j);
 }
