/*
 * Soubor:  interpret.h
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Hlavikov sbor interpretra
 */


#ifndef _INTERPRET_H_
#define _INTERPRET_H_


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <math.h>
#include "hash.h"
#include "str.h"
#include "list.h"
#include "sort.h"
#include "find.h"



/*
#define CIN_INTEGER 1         //
#define CIN_DOUBLE 2          //
//#define CIN_STRING 3        //
#define COUT_INTEGER 4        //
#define COUT_DOUBLE 5         //
#define COUT_STRING 6         //
#define NOT 8                 //
#define GOTO 9                //
#define GOTO_CONDITION 10     //
#define RETURN_INT 11         //
#define LENGHT_STRING 12
#define SORT_STRING 13
#define FIND_STRING 14
#define CONCAT_STRING 15
#define ABOVE_INTEGER 16      //
#define ABOVE_DOUBLE 17       //
#define ABOVE_STRING 18       //
#define ABOVEQUAL_INTEGER 19  //
#define ABOVEQUAL_DOUBLE 20   //
#define ABOVEQUAL_STRING 21   //
#define EQUAL_INTEGER 22      //
#define EQUAL_DOUBLE 23       //
#define EQUAL_STRING 24       //
#define NOT_EQUAL_INTEGER 25  //
#define NOT_EQUAL_DOUBLE 26   //
#define NOT_EQUAL_STRING 27   //
#define LESS_INTEGER 28       //
#define LESS_DOUBLE 29        //
#define LESS_STRING 30        //
#define LESSOREQUAL_INT 31    //
#define LESSOREQUAL_DOUBLE 32 //
#define LESSOREQUAL_STRING 33 //
#define ADD_INTEGER 34        //
#define ADD_DOUBLE 35         //
#define ADD_STRING 36
#define SUB_INTEGER 37         //
#define SUB_DOUBLE 38          //
#define MULL_INTEGER 39        //
#define MULL_DOUBLE 40         //
#define DIV_INTEGER 41         //
#define DIV_DOUBLE 42          //
#define PRIRADENIE_INTEGER 43  //
#define PRIRADENIE_DOUBLE 44   //
#define PRIRADENIE_STRING 45   //
#define RETYPE_INT_TO_REAL 46  //
*/


/*
// hlavicka pro interpret
int interpret(tSymbolTable *ST, tListOfInstr *instrList);


void listInit(tListOfInstr *L);
void listFree(tListOfInstr *L);
void listInsertLast(tListOfInstr *L, tInstr I);
void listFirst(tListOfInstr *L);
void listNext(tListOfInstr *L);
void listGoto(tListOfInstr *L, void *gotoInstr);
void *listGetPointerLast(tListOfInstr *L);
tInstr *listGetData(tListOfInstr *L);
*/

int interpret(torderlist *);

void cin_integer(tprvek*);                      //
void cin_double(tprvek*);                       //
void cin_string(tprvek*);
void cout_integer(tprvek*);                     //
void cout_double(tprvek*);                      //
void cout_string(tprvek*);                      //
void not_fce(tprvek*, tprvek*);                 //
void goto_fce(torderPtr*, tprvek*);
void goto_condition(torderPtr*, tprvek*, tprvek*, torderlist*);
void add_integer(tprvek*, tprvek*, tprvek*);    //
void sub_integer(tprvek*, tprvek*, tprvek*);    //
void mull_integer(tprvek*, tprvek*, tprvek*);   //
void div_integer(tprvek*, tprvek*, tprvek*);    //
void add_double(tprvek*, tprvek*, tprvek*);     //
void sub_double(tprvek*, tprvek*, tprvek*);     //
void mull_double(tprvek*, tprvek*, tprvek*);    //
void div_double(tprvek*, tprvek*, tprvek*);     //
void less_integer(tprvek*, tprvek*, tprvek*);   //
void less_double(tprvek*, tprvek*, tprvek*);    //
void less_string(tprvek*, tprvek*, tprvek*);    //
void above_integer(tprvek*, tprvek*, tprvek*);     //
void above_double(tprvek*, tprvek*, tprvek*);      //
void above_string(tprvek*, tprvek*, tprvek*);      //
void lessorequal_int(tprvek*, tprvek*, tprvek*);    //
void lessorequal_double(tprvek*, tprvek*, tprvek*); //
void lessorequal_string(tprvek*, tprvek*, tprvek*); //
void abovequal_integer(tprvek*, tprvek*, tprvek*);  //
void abovequal_double(tprvek*, tprvek*, tprvek*);   //
void abovequal_string(tprvek*, tprvek*, tprvek*);   //
void equal_integer(tprvek*, tprvek*, tprvek*);      //
void equal_double(tprvek*, tprvek*, tprvek*);      //
void equal_string(tprvek*, tprvek*, tprvek*);      //
void not_equal_integer(tprvek*, tprvek*, tprvek*);  //
void not_equal_double(tprvek*, tprvek*, tprvek*);   //
void not_equal_string(tprvek*, tprvek*, tprvek*);   //
void priradenie_integer(tprvek*, tprvek*);         //
void priradenie_double(tprvek*, tprvek*);          //
void priradenie_string(tprvek*, tprvek*);
void retype_int_to_real(tprvek*);
int return_int(tprvek*);

void lenght_string(tprvek*, tprvek*);
void sort_string(tprvek* );
void find_str(tprvek *,tprvek * ,tprvek *);
void concat_string(tprvek *, tprvek * , tprvek *);

#endif
