/*
 * Soubor:  list.h
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Hlavikov sbor operci nad zoznamom intrukci 3AK
 */

#ifndef _LIST_H_
#define _LIST_H_

#include "error.h"
#include "scanner.h"
#include "hash.h"
#include <stdlib.h>

#define CIN_INTEGER 101
#define CIN_DOUBLE 102
#define CIN_STRING 103
#define COUT_INTEGER 104
#define COUT_DOUBLE 105
#define COUT_STRING 106
#define LABEL 107
#define NOT 108
#define GOTO 109
#define GOTO_CONDITION 110
#define RETURN_INT 111
#define LENGHT_STRING 112
#define SORT_STRING 113 
#define FIND_STRING 114
#define CONCAT_STRING 115
#define ABOVE_INTEGER 116
#define ABOVE_DOUBLE 117
#define ABOVE_STRING 118
#define ABOVEQUAL_INTEGER 119
#define ABOVEQUAL_DOUBLE 120
#define ABOVEQUAL_STRING 121
#define EQUAL_INTEGER 122
#define EQUAL_DOUBLE 123
#define EQUAL_STRING 124
#define NOT_EQUAL_INTEGER 125
#define NOT_EQUAL_DOUBLE 126
#define NOT_EQUAL_STRING 127
#define LESS_INTEGER 128
#define LESS_DOUBLE 129
#define LESS_STRING 130
#define LESSOREQUAL_INT 131
#define LESSOREQUAL_DOUBLE 132
#define LESSOREQUAL_STRING 133
#define ADD_INTEGER 134
#define ADD_DOUBLE 135
#define ADD_STRING 136
#define SUB_INTEGER 137
#define SUB_DOUBLE 138
#define MUL_INTEGER 139
#define MUL_DOUBLE 140
#define DIV_INTEGER 141
#define DIV_DOUBLE 142
#define PRIRADENIE_INTEGER 143
#define PRIRADENIE_DOUBLE 144
#define PRIRADENIE_STRING 145
#define RETYPE_INT_TO_REAL 146
#define ID_DOUBLE 147
#define ID_STRING 148
#define ID_INT 149


//jedna instrukcia
typedef struct order
{
 int operation;
 tprvek *uk1;
 tprvek *uk2;
 tprvek *uk3;
 struct order *next;       
} *torderPtr;

//zoznam instrukcii pre interpret

typedef struct list
{
   torderPtr first;
   torderPtr last;
   torderPtr act;     
}torderlist;

void init_list(torderlist *list);
void free_list(torderlist *list);
void insert_list(torderlist *list,int operation, tprvek *uk1, tprvek *uk2, tprvek *uk3);
torderPtr *active_list(torderlist *list);

#endif
