/*
 * Soubor:  parser.c
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Parser - syntaktick analza zhora nadol, zdola nahor 
 *          a smantick analza
 */

#include "parser.h"

const char *keyword[] = { "int", "double", "string", "main", "else", "if", "while", "cin", "cout", "length", "find", "sort", "concat", "return"};



//Uvodna funkcia parser,ktora je volana mainom
//Funkciou zacina syntakticka analyza
int parser(thtab *t,tprvek **item,torderlist *list,FILE *file)
{
int token;
   
   token = LoadToken(file,t,item);
   if(START(t,item,list,file,&token))
   {
                       return TRUE;
   }
   else 
   {
        if(error == ERR_EOK)
        {
        error = ERR_SA;
        }
        return FALSE;
   }
}


/*Funkcia start simuluje tieto pravidla:  */
/*<START> -> double id;<START>            */          
/*<START> -> string id;<START>            */
/*<START> -> int <HEAD>                   */

int START(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token)
{
    int i;
    if((*token) == RESW)                                 //Zistujeme ci je na vstupe rezervovane slovo
    {
                for(i=0;i<3;i++)
                {
                                if(strcmp((*item)->jmeno,keyword[i]) == 0)            //Vyberame z prvych troch moznosti int double a string
                                {
                                      if(i == 0)                                      //Nasli sme int
                                      {
                                          return HEAD(t,item,list,file,token);        //Zavolame funkciu HEAD
                                      }
                                       else
                                      {
                                          *token = LoadToken(file,t,item);             //nasli sme double alebo string,nacitame dalsi token
                                        if((*token) == IDENTIFIER)                     //ak je identifikator
                                        {
                                             if((*item)->typ == UNDEFINED)             //ak je nedeklarovany
                                             {
                                               switch(i)                                //priradime mu typ
                                               {
                                                        case 1: (*item)->typ = N_DOUBLE;
                                                                break;
                                                        case 2: (*item)->typ = RETKONS;
                                                                (*item)->hodnota.retezec = NULL;
                                                                break;
                                                        default:
                                                               (*item)->typ = UNDEFINED;
                                                               break;
                                                }
                                               }
                                               else                     //uz bola deklarovana premmena
                                               {
                                               error = ERR_SEM;         //nastava semanticka chyba
                                               return FALSE;
                                               }
                                               *token = LoadToken(file,t,item);          //nacitame dalsi token
                                               if((*token) == SEMICOLON)                 //ak je strednik
                                                           {
                                                           *token = LoadToken(file,t,item);
                                                    return START(t,item,list,file,token);     //pokracujeme v deklaracii volanim funkcie START
                                                           }
                                                           else
                                                           {
                                                               return FALSE;
                                                           }
                                          }
                                           else
                                           {
                                             return FALSE; 
                                            }
                                        }
                                }
                }
}
return FALSE;

}

/*Funkcia HEAD simuluje tieto pravidla */
/*<HEAD> -> id;<START>                 */
/*<HEAD> -> main(){<TeloP> EOF         */  

int HEAD(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token)
{
    *token = LoadToken(file,t,item);
    if((*token) == IDENTIFIER)                                   //ak je identifikator
    {
                if((*item)->typ == UNDEFINED)                    //ak je nedefinovany
                {
                (*item)->typ = N_INT;                            //priradim mu typ int
                }
                else
                {
                     error = ERR_SEM;                            //inak semanticka chyba
                     return FALSE;
                }
                *token = LoadToken(file,t,item);
                if((*token) == SEMICOLON)                        //ak je deklaracia ukoncena strednikom
                            {
                *token = LoadToken(file,t,item);
                      return START(t,item,list,file,token);      //pokracujem v deklaracii volanim funkcie START
                            }
                            else
                            {
                                return FALSE;
                            }
    }else if ((*token) == RESW)                                   //ak prislo rezervovane slovo
    {
          if(strcmp((*item)->jmeno,keyword[3]) == 0)              //ak prisiel main
          {
            *token = LoadToken(file,t,item);                      //zistujem sekvenciu znakov main(){
            if((*token) == L_PARENTHESIS)
            {
                        *token = LoadToken(file,t,item);
                        if((*token) == R_PARENTHESIS)
                        {
                                   *token = LoadToken(file,t,item);
                                   if((*token) == L_BRACE)
                                   {
                                               *token = LoadToken(file,t,item);
                                       if(TeloP(t,item,list,file,token))                 //ak sa mi podarilo najst main(){ volam funkciu TeloP
                                                          {
                                                           if((*token) == MUJEOF)        //ak vsetko prebehne v poriadku,a vrati sa mi EOF ukoncim 
                                                                       {                 //ukoncim analyzu uspesne
                                                                       return TRUE;       
                                                                       }
                                                                       else               //inak neuspesne
                                                                       {    
                                                                            return FALSE;
                                                                        }
                                                                       
                                                           
                                                           }
                                                           else
                                                           { 
                                                           return FALSE;
                                                           }
                                                           
                                   }
                                   else
                                   {
                                       return FALSE;
                                   }
                        }
                        else
                        {
                            return FALSE;
                        }
            }
            else
            {
                return FALSE;
            } 
                                               
       }
       else
       {
           return FALSE;
       }
    }
return FALSE;
}
/*Funkcia generuje tieto pravidla : */
/*<TeloP> -> <prikaz> <TeloP>       */
/*<TeloP> -> }                      */

int TeloP(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token)
{
    int i;
    if((*token) == R_BRACE)                               //ak je {
    {
                *token = LoadToken(file,t,item);
                return TRUE;                              //Funkcia TeloP skoncila uspesne
                }
    if((*token) == L_PARENTHESIS)                         //ak je (
    {
            if(prikaz(t,item,list,file,token))            //volam funkciu prikaz
              {
                                   return TeloP(t,item,list,file,token);
                                   }
                                   else
                                   {
                                       return FALSE;
                                   }  
              }
              
    if((*token) == RESW || (*token) == IDENTIFIER)             //Ak rezervovane slovo alebo identifikator
    {
              if((*token) == IDENTIFIER)                       //ak identifikator
              {
                        if(prikaz(t,item,list,file,token))        //volam funkciu prikaz
                                   {
                                   return TeloP(t,item,list,file,token);         //presla uspesne vraciam sa do TelaP
                                   }
                                   else
                                   {
                                       return FALSE;
                                   }
              }
              for(i = 5;i <= 13;i++)                                    //hladam rezervovane slovo
              {
                    if(strcmp((*item)->jmeno,keyword[i])== 0)          //ak najdem
                    {
                           if(prikaz(t,item,list,file,token))          //volam funkciu prikaz
                                   {
                                   return TeloP(t,item,list,file,token);
                                   }
                                   else
                                   {
                                       return FALSE;
                                   }                                
                    }
              }
     }
return FALSE;
}


/*Funkcia generuje tieto pravidla                */
/*<prikaz> -> cin >> id <zoznam_cin>             */
/*<prikaz> -> cout << <vyraz> <zoznam_cout>      */
/*<prikaz> -> <vyraz>;                           */
/*<prikaz> -> if <vyraz>{<TeloP> else{<TeloP>    */
/*<prikaz> -> while<vyraz>{<TeloP>               */
/*<prikaz> -> return <vyraz>;                    */

int prikaz(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token)
{
int i;
torderPtr pom1;
torderPtr pom2;
if((*token) == L_PARENTHESIS)                                       //Ak je (
{
            if(expresion(t,item,list,file,token))                   //volam funkciu na vzhodnocovanie vyrazov
            {
                            if((*token) == SEMICOLON)               //ujistim sa ze posledny znak bol korektny
                                        {
                                      *token = LoadToken(file,t,item);
                                      return TRUE;
                                        }
                                      else
                                        {
                                          return FALSE;
                                        }
            }
            else
            {
            return FALSE;
            }
            
}  

if((*token) == IDENTIFIER)                                        //ak je identifikator
{
    if(expresion(t,item,list,file,token))                         //vola funkciu na vyhodnotenie vyrazov
       {
                            if((*token) == SEMICOLON)
                            {
                             *token = LoadToken(file,t,item);
                             return TRUE;
                            }
                            else
                            {
                             return FALSE;
                            }
       }
       else
       {
       return FALSE;
       }    
}
if((*token) == RESW)                                   //ak je to rezervovane slovo
{
          if(strcmp((*item)->jmeno,"cin") == 0)        //ak je to cin
          {
              *token = LoadToken(file,t,item);
              if((*token) == IN)   
              {
                        *token = LoadToken(file,t,item);
                        if((*token) == IDENTIFIER)
                        {
                                  switch((*item)->typ)                                //vygenerujem instrukciu podla typu         
                                  {
                                     case N_INT:     insert_list(list,CIN_INTEGER,NULL,NULL,(*item));
                                                     break;
                                     case N_DOUBLE:  insert_list(list,CIN_DOUBLE,NULL,NULL,(*item));
                                                     break;
                                     case RETKONS:   insert_list(list,CIN_STRING,NULL,NULL,(*item));
                                                     break;
                                     case UNDEFINED: error = ERR_SEM;               //inak semanticka chyba
                                                     return FALSE;
                                                     break;
                                     default:        error = ERR_SEM;
                                                     return FALSE;               
                                  }
                                  *token = LoadToken(file,t,item);
                                  return zoznam_cin(t,item,list,file,token);       //volam funkciu cin pre viac nacitani
                        }
                        else
                        {
                            return FALSE;
                        }
              }
              else
              {
              return FALSE;
              }
          }
          if(strcmp((*item)->jmeno,"cout") == 0)                      //ak je cout
          {
               *token = LoadToken(file,t,item);
               if((*token) == OUT)
               {
                           *token = LoadToken(file,t,item);
                           if(expresion(t,item,list,file,token))     //volam funkciu na vyhodnotenie vyrazu
                           {
                                        switch((*item)->typ)          //vygenerujem trojadresny kod podla typu
                                        {
                                        case N_INT:     insert_list(list,COUT_INTEGER,NULL,NULL,(*item));
                                                        break;
                                        case N_DOUBLE:  insert_list(list,COUT_DOUBLE,NULL,NULL,(*item));
                                                        break;
                                        case RETKONS:   insert_list(list,COUT_STRING,NULL,NULL,(*item));
                                                        break;
                                        case UNDEFINED: error = ERR_SEM;                 //inak semanticka chyba
                                                        return FALSE;
                                                        break;
                                        default:        error = ERR_SEM;
                                                        return FALSE; 
                                        }
                                        
                                        return zoznam_cout(t,item,list,file,token);   //volanie funkcie pre viac vystupov
                           }
                           else
                           {
                               return FALSE;
                           }
               }
               else
               {
                   return FALSE;
               }
               
          }
          if(strcmp((*item)->jmeno,"if") == 0)                           //ak je if
          {
                   *token = LoadToken(file,t,item);
                  if(expresion(t,item,list,file,token))                  //volam funkciu na vyhodnotenie vyrazov
                  {
                                      if((*item)->typ != N_INT)          //test ci je int
                                      {     
                                            error = ERR_SEM;             //ak nieje,semanticka chyba
                                            return FALSE;          
                                                      }
                            insert_list(list,NOT,(*item),NULL,(*item));                   //vkladam instrukciu not a podmieneneho skoku
                            insert_list(list,GOTO_CONDITION,(*item),NULL,NULL);
                            
                            pom1 = list->last;
                                      
                               if((*token) == L_BRACE)
                               {
                               *token = LoadToken(file,t,item);
                                       if(TeloP(t,item,list,file,token))
                                       {
                                                      insert_list(list,GOTO,NULL,NULL,NULL);               //vkladam instrukciu goto
                                                      pom2 = list->last;
                                                      insert_list(list,LABEL,NULL,NULL,NULL);              //kladam navestie
                                                      pom1->uk3 =(tprvek *) list->last;                    //ukazujem kam ma skocit
                                                      if((*token) == RESW)                                 //pride rezervovane slovo
                                                      {
                                                                if(strcmp((*item)->jmeno,"else") == 0)       //ak je to else
                                                                {
                                                                *token = LoadToken(file,t,item); 
                                                                        if((*token) == L_BRACE)
                                                                        {
                                                                                    *token = LoadToken(file,t,item);
                                                                                    if(TeloP(t,item,list,file,token))
                                                                                                           {
                                                                                                           insert_list(list,LABEL,NULL,NULL,NULL);  //vlozi druhe navestie kam sa moze skakat
                                                                                                           pom2->uk3 = (tprvek *) list->last;      //nastavi sa kam ma skakat
                                                                                                           return TRUE;
                                                                                                           }
                                                                                                           else
                                                                                                           {
                                                                                                               return FALSE;
                                                                                                           }
                                                                        }
                                                                        else
                                                                        {
                                                                        return FALSE;
                                                                        }
                                                                }
                                                                else
                                                                {
                                                                return FALSE;
                                                                }
                                                      }
                                                      else
                                                      {
                                                      return FALSE;
                                                      }    
                                           }
                                           else
                                           {
                                               return FALSE;
                                           }              
                                  }
                                  else
                                  {
                                      return FALSE;
                                  }
                  }
                  else
                  {
                      return FALSE;
                  }         
                                       
          }
          if(strcmp((*item)->jmeno,"while") == 0)                               //ak je while
     {
           insert_list(list,LABEL,NULL,NULL,NULL);                            //urcim si navestie
           pom1 = list->last;
           
           *token = LoadToken(file,t,item);
           
           if(expresion(t,item,list,file,token))                             //zavolam funkciu na vyhodnotenie vyrazu
           {
                                      if((*item)->typ != N_INT)              //ak sa nerovna int vysledok vyrazu
                                      {
                                                      error = ERR_SEM;       //semanticka chyba
                                                      return FALSE;
                                                      }
           insert_list(list,NOT,(*item),NULL,(*item));                       //vlozim instrukciu not a podmieneneho skoku goto_condition
           insert_list(list,GOTO_CONDITION,(*item),NULL,NULL);
           pom2 = list->last;
                   if((*token) == L_BRACE)
                   {
                               *token = LoadToken(file,t,item);
                         if(TeloP(t,item,list,file,token))                    //po uspesnom vykonani sekvencie prikazov
                         {
                               insert_list(list,GOTO,NULL,NULL,(tprvek *) pom1);         //vlozim instrukciu goto a dalsie navestie
                               insert_list(list,LABEL,NULL,NULL,NULL);
                               pom2->uk3 = (tprvek *) list->last;                       //nastavim kam ma skocit
                               return TRUE;               
                         }
                         else
                         {
                             return FALSE;
                         }
                                  
                   }
                   else
                   {
                       return FALSE;
                   }
           }
           else
           {
               return FALSE;
           }
                                           
     }
          if(strcmp((*item)->jmeno,"return") == 0)                           //ak je return
          {
          *token = LoadToken(file,t,item);
          if(expresion(t,item,list,file,token))                              //vyhodnotim vyraz
                   {
                                     if((*item)->typ != N_INT)               //ak sa vyraz nerovna int
                                                     {
                                              error = ERR_SEM;               //vratim semanticku chybu
                                              return FALSE;       
                                                     }
                                     insert_list(list,RETURN_INT,NULL,NULL,(*item));             //generujem instrukciu return_int
                                     if((*token) == SEMICOLON)
                                     {
                                                 *token = LoadToken(file,t,item);
                                                 return TRUE;                                      //uspesne ukoncim
                                     }
                                     else
                                     {
                                      return FALSE; 
                                     }
                    }
                                            
                                            
          }
          for(i = 9; i <= 12; i++)                                                  //vyhladava vstavane funkcie
          {
                if(strcmp((*item)->jmeno,keyword[i]) == 0)
                {
                    if(expresion(t,item,list,file,token))
                    {
                                     if((*token) == SEMICOLON)
                                                 {
                                        *token = LoadToken(file,t,item);
                                        return TRUE;
                                                 }
                                        else
                                            {
                                            return FALSE;
                                            }
                                        
                    }
                    else
                    {
                    return FALSE;
                    }                                 
                }
          }
}
return FALSE;

}

int zoznam_cin(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token)
{
    if((*token) == IN)                                                          //ak je dalsi vstup
    {
                *token = LoadToken(file,t,item);
                if((*token) == IDENTIFIER)
                {
                       switch((*item)->typ)                                     //vygeneruje instrukciu podla typu
                       {
                          case N_INT: insert_list(list,CIN_INTEGER,NULL,NULL,(*item));
                                      break;
                                      
                          case N_DOUBLE: insert_list(list,CIN_DOUBLE,NULL,NULL,(*item));
                                       break;
                                       
                          case RETKONS: insert_list(list,CIN_STRING,NULL,NULL,(*item));
                                        break;
                          
                          case UNDEFINED: error = ERR_SEM;
                                          return FALSE;
                                          break;
                          default:        error = ERR_SEM;
                                          return FALSE;
                       }
                          *token = LoadToken(file,t,item);
                          return zoznam_cin(t,item,list,file,token);                       
                }
                else
                {
                    return FALSE;
                }
    }else if((*token) == SEMICOLON)                                 //ukoncenie cin
          {
          *token = LoadToken(file,t,item);
          return TRUE;
          }
    else
    return FALSE;
}

int zoznam_cout(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token)
{
    if((*token) == OUT)                                           //dalsi vystup
    {
                *token = LoadToken(file,t,item);
                if(expresion(t,item,list,file,token))
                           {
                                        switch((*item)->typ)                   //vygeneruje podla typu instrukciu
                                        {
                                        case N_INT:    insert_list(list,COUT_INTEGER,NULL,NULL,(*item));
                                                       break;
                                        case N_DOUBLE: insert_list(list,COUT_DOUBLE,NULL,NULL,(*item));
                                                       break;
                                        case RETKONS:  insert_list(list,COUT_STRING,NULL,NULL,(*item));
                                                       break;
                                        case UNDEFINED: error = ERR_SEM;
                                                        return FALSE;
                                                       break;
                                        default:  error = ERR_SEM;
                                                  return FALSE; 
                                        }
                                        return zoznam_cout(t,item,list,file,token);
                           }
                           else
                           {
                               return FALSE;
                           }
    }
    else if((*token) == SEMICOLON)                          //ukoncenie cout
         {
         *token = LoadToken(file,t,item);
         return TRUE;
         }
    else
    return FALSE;
    
}


/*********************************************************

  Syntakticka analyza zdola nahor - vyhodnotenie vyrazov

*********************************************************/


int expresion(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token)
{
    

    if ((*token) == SEMICOLON) return FALSE;
    tzasobnik zasobnik;
    zasobnik_init(&zasobnik);
    zasobnik_push(&zasobnik, T_DOLAR, NULL);
    if(kontrola_vyrazu(t, item, file, token, list, &zasobnik))
    {
        zasobik_zrus(&zasobnik);
        return TRUE;
    } 
    else
    { 
        zasobik_zrus(&zasobnik);
        return FALSE;
    }
    return FALSE;    
}
  
  
  
int kontrola_vyrazu(thtab *t, tprvek **item, FILE *file, int *token, torderlist *list, tzasobnik *zasobnik)
{
  tprvek *pomocna, *pomocna1, *pomocna2, *pomocna3, *pomocna4, *pomocna5, *pomocna_vysled ;
  TPretypovanie tmp;
  int pom, pom1, pom2, pom3, pom4, pom5, zasob, vstup;
  char znak;
  
  char *precedencna[17] = 
  {
  //precedencna tabulka
//           ====  $<$
// +-*/=()i<><>=!f,{<; 
  ">><<><><>>>>>><>>>>", //...+
  ">><<><><>>>>>><>>>>", //...-
  ">>>>><><>>>>>><>>>>", //...*
  ">>>>><><>>>>>><>>>>", //.../
  "<<<<<<><<<<<<<<>>>>", //...=
  "<<<<<<=<<<<<<<<=000", //...(
  ">>>>>0>0>>>>>>0>>>>", //...)
  ">>>>>0>0>>>>>>0>>>>", //...i
  "<<<<><><>>>>>><>>>>", //...<
  "<<<<><><>>>>>><>>>>", //...>
  "<<<<><><>>>>>><>>>>", //...<=
  "<<<<><><>>>>>><>>>>", //...>=
  "<<<<><><<<<<>><>>>>", //...==
  "<<<<><><<<<<>><>>>>", //...!=
  "00000=0000000000000", //...f - funkcia
  "<<<<<<=<<<<<<<<0000", //...,
  "<<<<<<0<<<<<<<<0000", //...$...{
  };
  
  do
  {
    switch(*token)
    {
      case PLUS:                vstup = T_PLUS;             break; // +....0
      case MINUS:               vstup = T_MINUS;            break; // -....1
      case MUL:                 vstup = T_MUL;              break; // *....2
      case DIV:                 vstup = T_DIV;              break; // /....3
      case EQUAL:               vstup = T_EQUAL;            break; // =....4
      case L_PARENTHESIS:       vstup = T_L_PARENTHESIS;    break; // (....5
      case R_PARENTHESIS:       vstup = T_R_PARENTHESIS;    break; // )....6
      case IDENTIFIER:          vstup = T_IDENTIFIER;       break; // i....7
      case N_INT:               vstup = T_IDENTIFIER;       break; // i....7
      case N_DOUBLE:            vstup = T_IDENTIFIER;       break; // i....7
      case RETKONS:             vstup = T_IDENTIFIER;       break; // i....7...retazec
      case LESS:                vstup = T_LESS;             break; // <....8
      case GREATER:             vstup = T_GREATER;          break; // >....9
      case LESSOREQUAL:         vstup = T_LESSOREQUAL;      break; // <=..10
      case GREATEROREQUAL:      vstup = T_GREATEROREQUAL;   break; // >=..11
      case ISEQUAL:             vstup = T_ISEQUAL;          break; // ==..12
      case NOT_EQUAL:           vstup = T_NOT_EQUAL;        break; // !=..13
      case RESW:                vstup = T_RESW;             break; // f...14 ...rezervovane slova funkcii
      case COMMA:               vstup = T_COMMA;            break; // ,...15
      case L_BRACE:             vstup = T_DOLAR;            break; // {...16
      case OUT:                 vstup = T_DOLAR;            break; // <<..16 
      case SEMICOLON:           vstup = T_DOLAR;            break; // ;...16
      default:                  vstup = -1;                 break;	
      
    }
    
    if((vstup == T_IDENTIFIER) && ((*item)->typ == UNDEFINED))
    {
    error = ERR_SEM;
    return FALSE; 
    }
    
    zasob = zasobnik_vnorenie(zasobnik); // najdeme si navrchnejsi terminalny symbol
    while(zasob == TN_NETERMINAL)
    {
      zasob = zasobnik_vnorenie(zasobnik);
      if(zasob == KONIEC)
	    {
            return FALSE;
	    }                                                              
    } 
    // URCENIE PRAVIDLA PODLA PRECEDENCNEJ TABULKY    
    znak = precedencna[zasob][vstup]; 
    
    if(znak == '=' || znak == '<') 
    {
      zasobnik_push(zasobnik, vstup, (*item));	// symbol zo vstupu dame na vrchol zasobnika
      *token = LoadToken(file,t,item); 	        // nacitame si dalsi token	
      zasob = zasobnik_vnorenie(zasobnik);
      if (zasob == KONIEC) 
          {
              return FALSE;
          }
      
      while(zasob == TN_NETERMINAL) // najdeme si predchadzajuci terminalny symbol
      {
          zasob = zasobnik_vnorenie(zasobnik);
          if (zasob == KONIEC) 
          {
              return FALSE;
          }
      }
      zasobnik -> act = zasobnik -> vrchol;  
    }
    // pokial nam ostalo na zasobniku $E a prichadza koniec vyrazu $: "{ << ;", ukoncime cely cyklus
    else if(zasob == T_DOLAR && vstup == T_DOLAR ) break; 
    else if (znak == '0') return FALSE;
    else if(znak == '>')
    {
        pom = zasobnik_toppop(zasobnik, &pomocna); // popneme si zo zasobnika znak, v "pomocna" je pointer na strukturu tprvek na vrchole zasobnika
 
         
        if(pom == T_IDENTIFIER) // pokial mame na vrchole i, urobime pravidlo E -> i
        {
            pomocna_vysled = htable_lookup(t, NULL, NULL, pomocna -> typ);                               
            if(pomocna -> typ == RETKONS) 
            {
              insert_list(list, PRIRADENIE_STRING, pomocna, NULL, pomocna_vysled); 
            }
            else if(pomocna -> typ == N_INT) 
            {
            	insert_list(list, PRIRADENIE_INTEGER, pomocna, NULL, pomocna_vysled);
            }
            else if(pomocna -> typ == N_DOUBLE) 
            {
            	insert_list(list, PRIRADENIE_DOUBLE, pomocna, NULL, pomocna_vysled);
            }
            zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
        }

        else if(pom == T_R_PARENTHESIS) // ZATVORKA )
        {
            pom1 = zasobnik_toppop(zasobnik, &pomocna1);
            if(pom1 != TN_NETERMINAL) {return FALSE;}
            // E)
            pom2 = zasobnik_toppop(zasobnik, &pomocna2);

            
            if(pom2 == T_L_PARENTHESIS)
            {

              pom3 = zasobnik_toppop(zasobnik, &pomocna3);
              // pom3 urcuje ci je to f(E), alebo E->(E)
              if(pom3 == T_RESW) // f(E)
              { 
                if (pomocna1->typ != RETKONS) {error=ERR_SEM; return FALSE;}
                if (strcmp(pomocna3 -> jmeno, "length") == 0)
                {
                    pomocna_vysled = htable_lookup(t, NULL, NULL, N_INT);
                    zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                    insert_list(list, LENGHT_STRING, pomocna1, NULL, pomocna_vysled);
                }
                else if (strcmp(pomocna3 -> jmeno, "sort") == 0)
                {
                    pomocna_vysled = htable_lookup(t, NULL, NULL, RETKONS);
                    zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                    insert_list(list, SORT_STRING, pomocna1, NULL, pomocna_vysled);
                }
                else {error = ERR_SEM; return FALSE;}
              }
              // pravidlo E->(E)
              else {
                zasobnik_push(zasobnik,pom3,pomocna3);  zasobnik_push(zasobnik,TN_NETERMINAL,pomocna1);  }
              
            }  
            else if (pom2 == T_COMMA) 
            {
              if (pomocna1->typ != RETKONS) {error=ERR_SEM; return FALSE;}

              pom3 = zasobnik_toppop(zasobnik, &pomocna3);
              // ak je pom2 , akceptuje len pravidlo E->f(E,E)
              if(pom3 == TN_NETERMINAL) 
              { // E,E)
                pom4 = zasobnik_toppop(zasobnik, &pomocna4);
                if(pom4 != T_L_PARENTHESIS) { return FALSE; } // musi to byt (E,E) 
                pom5 = zasobnik_toppop(zasobnik, &pomocna5);
                if(pom5 == T_RESW)
                {
                   
                   if (pomocna3->typ != RETKONS) {error=ERR_SEM; return FALSE;}
                    if (strcmp(pomocna5 -> jmeno, "find") == 0)
                    {
                        pomocna_vysled = htable_lookup(t, NULL, NULL, N_INT);
                        zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                        insert_list(list, FIND_STRING, pomocna1, pomocna3, pomocna_vysled);
                    }
                    else if (strcmp(pomocna5 -> jmeno, "concat") == 0)
                    {
                        pomocna_vysled = htable_lookup(t, NULL, NULL, RETKONS);
                        zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                        insert_list(list, CONCAT_STRING, pomocna1, pomocna3, pomocna_vysled);
                    }
                    else {error = ERR_SEM; return FALSE;}
                }
                else {error = ERR_SEM; return FALSE;}
              }
              else {error = ERR_SEM; return FALSE;}
            }
            else {error = ERR_SEM; return FALSE; }
        }
        else if(pom == TN_NETERMINAL) // prava strana pravidla zacina na E
        {
            pom1 = zasobnik_toppop(zasobnik, &pomocna1);        
            pom2 = zasobnik_toppop(zasobnik, &pomocna2);
           
            if(pom2 == TN_NETERMINAL && ((pom1 >= 0 && pom1 <= 4) || (pom1 >= 8 && pom1 <= 13))) // pom2 == E; pom1 == +-*/= < > <= >= == !==
            {   
                // tu sa vola pretypovacia funkcia
                tmp = pravidla_pretypovania(pomocna -> typ, pomocna2 -> typ, pom1);   
                if(tmp.co_pretypovat == -1 || tmp.typ_vysledku == -1)
                {
                    error = ERR_SEM;
                    return FALSE;
                }	
	              else
                {
                    switch(tmp.co_pretypovat)
                    {
                        case NIC:	      break;
                        case PRVY:	    insert_list(list, RETYPE_INT_TO_REAL, pomocna2, NULL, NULL);
                                        break;
                        case DRUHY:	    insert_list(list, RETYPE_INT_TO_REAL, pomocna, NULL, NULL);
                                        break;
                        default:	      error = ERR_SEM;
                                        return FALSE;
                                        break;
                    }
                }
                // v tabulke symbolov sa vytvori nove miesto (pomocna_vysled) pre vsledok opercie (pom1) 
                
                pomocna_vysled = htable_lookup(t, NULL, NULL, tmp.typ_vysledku);
                switch(pom1)
                {
                    case T_PLUS:    zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled); // na zsobnik shiftneme nonterminl, ukazujci na vsledok
                                    // podla typu vsledku (kt. uruj pravidl pretypovania) pecifikujeme intrukciu
                                    if(tmp.typ_vysledku == N_INT) 
                                    {
                                        insert_list(list, ADD_INTEGER,pomocna2, pomocna, pomocna_vysled); 
                                    }
                                    else if(tmp.typ_vysledku == N_DOUBLE) 
                                    {
                                        insert_list(list, ADD_DOUBLE, pomocna2, pomocna, pomocna_vysled);
                                    }
                                    break;
	    
                    case T_MINUS:   zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                                    if(tmp.typ_vysledku == N_INT) 
                                    {
                                        insert_list(list, SUB_INTEGER, pomocna2, pomocna, pomocna_vysled);
                                    }                        	     
                                    else if(tmp.typ_vysledku == N_DOUBLE) 
                                    {
                                        insert_list(list, SUB_DOUBLE, pomocna2, pomocna, pomocna_vysled);
                                    }   
                    break;
      
                    case T_MUL:     zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                                    if(tmp.typ_vysledku == N_INT) 
                                    {
                                        insert_list(list, MUL_INTEGER, pomocna2, pomocna, pomocna_vysled);
                                    } 
                                    else if(tmp.typ_vysledku == N_DOUBLE) 
                                    {
                                        insert_list(list, MUL_DOUBLE, pomocna2, pomocna, pomocna_vysled);
                                    }
                                    break; 
	    
                    case T_DIV:   zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
	                                if(tmp.typ_vysledku == N_INT)
                                    {
                                        insert_list(list, DIV_INTEGER, pomocna2, pomocna, pomocna_vysled);
                                    }   
                                    else if(tmp.typ_vysledku == N_DOUBLE)
                                    {
                                        insert_list(list, DIV_DOUBLE, pomocna2, pomocna, pomocna_vysled);
                                    }  
                                    break;                  
	    
                    case T_EQUAL:   zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                                    if(tmp.typ_vysledku == N_INT)
                                    {
                                        insert_list(list, PRIRADENIE_INTEGER, pomocna, NULL, pomocna_vysled);
                                    } 
                                    if(tmp.typ_vysledku == N_DOUBLE)
                                    {
                                        insert_list(list, PRIRADENIE_DOUBLE, pomocna, NULL, pomocna_vysled);
                                    } 
                                    if(tmp.typ_vysledku == RETKONS)
                                    {
                                        insert_list(list, PRIRADENIE_STRING, pomocna, NULL, pomocna_vysled);
                                    }   
                                    break;
	    
                    case T_LESS:    zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                                    if(pomocna2->typ) 
                                    {
                                        insert_list(list ,LESS_INTEGER, pomocna2, pomocna, pomocna_vysled);

                                    }                        	     
                                    else if(pomocna2->typ == N_DOUBLE) 
                                    {
                                        insert_list(list, LESS_DOUBLE, pomocna2, pomocna, pomocna_vysled);
                                    }                     	     
                                    else if(pomocna2->typ == RETKONS) 
                                    {
                                        insert_list(list, LESS_STRING, pomocna2, pomocna, pomocna_vysled);
                                    }                             
                                    break;
	    
                    case T_GREATER: zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                                    if(pomocna2->typ == N_INT) 
                                    {
                                        insert_list(list, ABOVE_INTEGER, pomocna2, pomocna, pomocna_vysled);
                                    }                   	     
                                    else if(pomocna2->typ == N_DOUBLE) 
                                    {
                                        insert_list(list, ABOVE_DOUBLE, pomocna2, pomocna, pomocna_vysled);
                                    }                 	     
                                    else if(pomocna2->typ == RETKONS) 
                                    {
                                        insert_list(list, ABOVE_STRING, pomocna2, pomocna, pomocna_vysled);
                                    }                           
                                    break;	
	    
                    case T_LESSOREQUAL: zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                                        if(pomocna2->typ == N_INT) 
                                        {  
                                            insert_list(list, LESSOREQUAL_INT, pomocna2, pomocna, pomocna_vysled);
                                        }                	     
                                        else if(pomocna2->typ == N_DOUBLE) 
                                        {
                                            insert_list(list, LESSOREQUAL_DOUBLE, pomocna2, pomocna, pomocna_vysled);

                                        }                	     
                                        else if(pomocna2->typ == RETKONS) 
                                        {
                                            insert_list(list, LESSOREQUAL_STRING, pomocna2, pomocna, pomocna_vysled);
                                        }                        
                                        break;
	    
                    case T_GREATEROREQUAL:  zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                                            if(pomocna2->typ == N_INT) 
                                            {
                                                insert_list(list, ABOVEQUAL_INTEGER, pomocna2, pomocna, pomocna_vysled);
                                            }              	     
                                            else if(pomocna2->typ == N_DOUBLE) 
                                            {
                                                insert_list(list, ABOVEQUAL_DOUBLE, pomocna2, pomocna, pomocna_vysled);
                                            }                	     
                                            else if(pomocna2->typ == RETKONS) 
                                            {
                                                insert_list(list, ABOVEQUAL_STRING, pomocna2, pomocna, pomocna_vysled); 
                                            }                      
                                            break;
	    
                    case T_ISEQUAL: zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
                                    if(pomocna2->typ == N_INT) 
                                    {
                                        insert_list(list, EQUAL_INTEGER, pomocna2, pomocna, pomocna_vysled);
                                    }                  	     
                                    else if(pomocna2->typ == N_DOUBLE) 
                                    {
                                        insert_list(list, EQUAL_DOUBLE, pomocna2, pomocna, pomocna_vysled);
                                    }                  	     
                                    else if(pomocna2->typ == RETKONS) 
                                    {
                                        insert_list(list, EQUAL_STRING, pomocna2, pomocna, pomocna_vysled);
                                    }                          
                                    break;
	    
	                case T_NOT_EQUAL: zasobnik_push(zasobnik, TN_NETERMINAL, pomocna_vysled);
	                                  
	                                  if(pomocna2->typ == N_INT) 
                                    {
                                        insert_list(list, NOT_EQUAL_INTEGER, pomocna2, pomocna, pomocna_vysled);
                                    }                  	     
                                    else if(pomocna2->typ == N_DOUBLE) 
                                    {
                                        insert_list(list, NOT_EQUAL_DOUBLE, pomocna2, pomocna, pomocna_vysled);
                                    }                  	     
                                    else if(pomocna2->typ == RETKONS) 
                                    {
                                        insert_list(list, NOT_EQUAL_STRING, pomocna2, pomocna, pomocna_vysled);
                                    }
                                    break;
	    
                    default:	break;
                }	
            }
            else { return FALSE; }
        }
        else { return FALSE; } 
            
    }
    else { return FALSE; }     
    }
    while(((((*token) != OUT && (*token) != L_BRACE) && (*token) != SEMICOLON) || zasobnik->act->token != T_DOLAR) || zasobnik_prazdny(zasobnik));
    (*item) = pomocna_vysled;
    return TRUE;
}

