/*
 * Soubor:  parser.h
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Hlavikov sbor parseru
 */


#ifndef _PARSER_H_
#define _PARSER_H_

#define T_PLUS 0                        // indexy v precedencnej tabulke
#define T_MINUS 1                       // v syn. analyze zdola nahor
#define T_MUL 2
#define T_DIV 3
#define T_EQUAL 4
#define T_L_PARENTHESIS 5
#define T_R_PARENTHESIS 6
#define T_IDENTIFIER 7 
#define T_LESS 8 
#define T_GREATER 9 
#define T_LESSOREQUAL 10 
#define T_GREATEROREQUAL 11 
#define T_ISEQUAL 12 
#define T_NOT_EQUAL 13 
#define T_RESW 14
#define T_COMMA 15
#define T_DOLAR 16
#define TN_NETERMINAL 17

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "error.h"
#include "scanner.h"
#include "list.h"
#include "zasobnik.h"
#include "pretypovanie.h"
#include "str.h"
#include "hash.h"

int parser(thtab *t,tprvek **item,torderlist *list,FILE *file);

int START(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token);

int HEAD(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token);

int TeloP(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token);

int prikaz(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token);

int zoznam_cin(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token);

int zoznam_cout(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token);

int expresion(thtab *t,tprvek **item,torderlist *list,FILE *file,int *token);

int kontrola_vyrazu(thtab *t, tprvek **item, FILE *file, int *token, torderlist *list, tzasobnik *zasobnik);

#endif
