/*
 * Soubor:  pretypovanie.c
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Zdrojov sbor s pravidlami pretypovania vrazov
 */


#include "parser.h"
#include "scanner.h"



TPretypovanie pravidla_pretypovania(int operand_a, int operand_b, int operator)
{
  TPretypovanie vysledok;
    // pravidl pretypovania pre opertory +, -, *, /
    if ((operator == T_PLUS) || (operator == T_MINUS) || (operator == T_MUL) || (operator == T_DIV))
    { 
      if ((operand_a == N_INT) && (operand_b == N_INT)) 
        { vysledok.co_pretypovat = NIC; vysledok.typ_vysledku = N_INT; }
      else if ((operand_a == N_DOUBLE) && (operand_b == N_INT)) 
        { vysledok.co_pretypovat = DRUHY; vysledok.typ_vysledku = N_DOUBLE; }
      else if ((operand_a == N_INT) && (operand_b == N_DOUBLE)) 
        { vysledok.co_pretypovat = PRVY; vysledok.typ_vysledku = N_DOUBLE; }
      else if ((operand_a == N_DOUBLE) && (operand_b == N_DOUBLE)) 
        { vysledok.co_pretypovat = NIC; vysledok.typ_vysledku = N_DOUBLE; }
      else { vysledok.co_pretypovat = -1; vysledok.typ_vysledku = -1;}
    }
    
    // pravidl pretypovania pre opertory <, >, <=, >=, ==, !=
    else if ((operator == T_LESS) || (operator == T_GREATER) || (operator == T_LESSOREQUAL) || (operator == T_GREATEROREQUAL) || (operator == T_ISEQUAL) || (operator == T_NOT_EQUAL))
    { 
      if ((operand_a == N_INT) && (operand_b == N_INT))
        { vysledok.co_pretypovat = NIC; vysledok.typ_vysledku = N_INT; }
      else if ((operand_a == N_DOUBLE) && (operand_b == N_INT)) 
        { vysledok.co_pretypovat = DRUHY; vysledok.typ_vysledku = N_INT; }
      else if ((operand_a == N_INT) && (operand_b == N_DOUBLE)) 
        { vysledok.co_pretypovat = PRVY; vysledok.typ_vysledku =  N_INT; }
      else if ((operand_a == N_DOUBLE) && (operand_b == N_DOUBLE)) 
        { vysledok.co_pretypovat = NIC; vysledok.typ_vysledku = N_INT; }
      else if ((operand_a == RETKONS) && (operand_b == RETKONS)) 
        { vysledok.co_pretypovat = NIC; vysledok.typ_vysledku = N_INT; }  
      else { vysledok.co_pretypovat = -1; vysledok.typ_vysledku = -1;}
    }
    
    // pravidl pretypovania pre opertor priradenia
    else if (operator == T_EQUAL)
    {
      if ((operand_a == N_INT) && (operand_b == N_INT)) 
        { vysledok.co_pretypovat = NIC; vysledok.typ_vysledku = N_INT; }
      else if ((operand_a == N_DOUBLE) && (operand_b == N_DOUBLE)) 
        { vysledok.co_pretypovat = NIC; vysledok.typ_vysledku = N_DOUBLE; }
      else if ((operand_a == RETKONS) && (operand_b == RETKONS)) 
        { vysledok.co_pretypovat = NIC; vysledok.typ_vysledku = RETKONS; }
      else if ((operand_a == N_DOUBLE) && (operand_b == N_INT)) 
        { vysledok.co_pretypovat = DRUHY; vysledok.typ_vysledku = N_DOUBLE; }
      else { vysledok.co_pretypovat = -1; vysledok.typ_vysledku = -1;}
    }
  return vysledok;
}
