/*
 * Soubor:  scanner.h
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Lexikln analyztor - knihovna
 */


#ifndef _SCANNER_H_
#define _SCANNER_H_

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "hash.h"
#include "error.h"
#include "str.h"

#define TRUE 1
#define FALSE 0

//Definice druhu tokenu

typedef enum {
                N_INT,            //Integer
                N_DOUBLE,         //Double
                IDENTIFIER,       //Identifiktor
                MUL,              // *
                DIV,              // /
                PLUS,             // +
                MINUS,            // -
                LESS,             // <
                LESSOREQUAL,      // <=
                GREATER,          // >
                GREATEROREQUAL,   // >=
                EQUAL,            // =
                L_BRACE,          // {
                R_BRACE,          // }
                ISEQUAL,          // ==
                NOT_EQUAL,        // !=
                L_PARENTHESIS,    // (
                R_PARENTHESIS,    // )
                COMMA,             // ,
                IN,               // <<
                OUT,              // >>
                MUJEOF,           // EOF
                BADLEXEM,          // patn lexm
                SEMICOLON,        // ;
                RESW,             // Rezervovane slovo
                RETKONS,          // Retezcova konstanta
} TokenType;

int LoadToken (FILE *, thtab *, tprvek **);

// konec lexan.h
#endif
