/*
 * Soubor:  sort.c
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Zdrojov sbor vstavanej triediacej funkcie sort()
 *          - algoritmus HEAP SORT
 */


#include "sort.h"


void SiftDown(char **A, int left, int right)
{
  char i;
  int prom;

  i = (*A)[left - 1];

  while (left <= right / 2) {
    prom = 2*left;
    if ((prom < right) && ((*A)[prom - 1] < (*A)[prom])) {
      prom = prom + 1;
    }
    if (i >= (*A)[prom - 1]) {
      break;
    }
    else
    {
      (*A)[left - 1] = (*A)[prom - 1];
      left = prom;
    }
  }
  (*A)[left - 1] = i;
}

void heap_sort(char **A, int n)
{
  int left;
  //int right;
  //int i;
  char swap;

  for (left = n / 2; left > 0; left = left - 1) SiftDown( A, left, n);
  do {
    swap = (*A)[0];
    (*A)[0] = (*A)[n - 1];
    (*A)[n - 1] = swap;
    n = n - 1;
    SiftDown( A, 1, n);
  }while (n > 1);
}



