/*
 * Soubor:  str.c
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Spracovv retezce a vykonv veker operace nad nimy
 */

#include "str.h"
#include "error.h"

#define ALOC_SIZE 16

//Inicializacia alokacie retazca
string str_init()
{
 string str;
 if((str.text = malloc(ALOC_SIZE*sizeof(char))) == NULL)       //alokuje sa pamata pre retazec vo velkosti 16*sizeof(char)
 {
              error = ERR_ALOC;                                //doslo k chybe pri alokacii
               }
 memset(str.text,'\0',ALOC_SIZE*sizeof(char));                 //mastavuje sa pamata
 str.lenght = 0;                                               //dlzka retazka je rovna 0
 str.allocSize = ALOC_SIZE - 1;                                //alokovane miesto pre znaky je ALOC_SIZE - 1
return str;
}


//Funkcia uvolni retazec z pamate
void str_free(string *str)
{
 free(str->text);
 str->lenght = 0;
 str->allocSize = 0;
}

//Funkcia realokuje miesto pre retazec
void str_realoc(string *str)
{
     str->allocSize = str->allocSize + ALOC_SIZE;
     if((str->text = realloc(str->text,(str->allocSize)*sizeof(char))) == NULL)
     {
           error = ERR_ALOC;
            }
}

//Funkcia prida znak do retazca
void add_char(string *dest,char c)
{
     dest->lenght++;
     if((dest->lenght) >= (dest->allocSize))
     {
                 str_realoc(dest);
                       }
     char *s = dest->text;
     while(*s != '\0')
     {
              s++;
     }
     *s++ = c;
     *s = '\0';
}
//Funkcia vrati textovu cast retazca
char *strGetStr(string *src)
{
   return src->text;
}

//Funkcia vrati dlzku daneho retezce
int strGetLength(string *src)
{
   return src->lenght;
}

// Funkcia porovnava obidva retazce a vracia vysledok
int str_cmpstring(string *des, string *src)
{
   return strcmp(des->text, src->text);
}

// Funkcia porovna strukturu s retezcom
int str_cmpConstStr(string *des,const char *src)
{
   return strcmp(des->text , src);
}

//Funkcia prevedie konkatenaciu dvoch retazcov
void str_concat(string *des,string *src)
{
     des->lenght = des->lenght + src->lenght;
     while((des->lenght) >= des->allocSize)
     {
                         str_realoc(des);
                         }
strcat(des->text,src->text);
}

void str_scitanie_string(string *des,char *src)
{
     if(src != NULL)
     {
       des->lenght=strlen(src);
       while((des->lenght) >= (des->allocSize))
       {
                          str_realoc(des);
                           }
            strcat(des->text,src);
     }
 }

//Funkcia skopiruje retazec so src do des
void str_copy(string *des, string *src)
{
     des->lenght = src->lenght;
     while((des->lenght) >= (des->allocSize))
     {
                         str_realoc(des);
                         }
     strcpy(des->text , src->text);
 }

void str_copy_string(string *des,char *src)
{
     if(src != NULL)
     {
       des->lenght=strlen(src);
       while((des->lenght) >= (des->allocSize))
       {
                          str_realoc(des);
                           }
            strcpy(des->text,src);
     }
 }
