/*
 * Soubor:  zasobnik.c
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Zdrojov sbor s operciami nad ADT zsobnk
 */
 
 
#include "zasobnik.h"

//inicializujeme si zasobnik 
void zasobnik_init(tzasobnik *zasobnik)
  {
  zasobnik -> vrchol = NULL;
  zasobnik -> act = NULL;
  }
  
//zrusenie zasobnika
void zasobik_zrus(tzasobnik *zasobnik)
  {
  tprvek *pomocna;
  while(!zasobnik_prazdny(zasobnik))
    {
    zasobnik_toppop(zasobnik, &pomocna);
    }
  }
  
//funkcia na zistenie ci je zasobnik prazdny 
int zasobnik_prazdny(tzasobnik *zasobnik)    
  {
  if (zasobnik -> vrchol == NULL) return TRUE;
  else return FALSE;
  }
  
//funkcia, ktora maze prvy prvok na zasobniku - na vrchole zasobnika
int zasobnik_toppop(tzasobnik *zasobnik, tprvek **ptr)
  {
  tzasobnikitemPtr tmp;
  int pomocna;

  if(zasobnik_prazdny(zasobnik)) return KONIEC;
  else  
    {
    pomocna = zasobnik -> vrchol -> token;
    (*ptr) = zasobnik -> vrchol -> ptr;
    tmp = zasobnik -> vrchol;
    zasobnik -> vrchol = zasobnik -> vrchol -> next;
    free(tmp);
    zasobnik -> act = zasobnik -> vrchol;
    return pomocna;
    }	
  }

//funkcia nam vracia dalsi prvok a vstupuje do neho hlbsie - zanorenie do zasobnika 
int zasobnik_vnorenie(tzasobnik *zasobnik)
  {
  int tmp;
  if(zasobnik -> act != NULL)                // pokial sme sa este nedostali na koniec
    {
    tmp = zasobnik -> act -> token;        // vrat aktualny token
    zasobnik -> act = zasobnik -> act -> next;    // posun na dalsi prvok
    }
  else tmp = KONIEC;  
  return tmp;
  }

//funkcia, ktora nam ulozi prvok na zasobnik
void zasobnik_push(tzasobnik *zasobnik, int cislo, tprvek *ptr)
  {
  tzasobnikitemPtr tmp;
  if((tmp = malloc(sizeof(struct zasobnik_item))) == NULL)
    {
    error = ERR_ALOC;
    return;
    }
  tmp -> token = cislo;                     // naplnenie prvku
  tmp -> ptr = ptr;
  tmp -> next = zasobnik -> vrchol;
  zasobnik -> vrchol = tmp;
  zasobnik -> act = zasobnik -> vrchol;
  }
