/*
 * Soubor:  zasobnik.c
 * Datum:   14.12.2008
 * Autori:  Barto Luk     xbarto55@fit.vutbr.cz                           *
 *          ervienka Juraj  xcervi09@fit.vutbr.cz                           *
 *          uri Michal     xduris01@fit.vutbr.cz                           *
 *          Elis Martin      xelism00@fit.vutbr.cz                           *
 *          Herich Martin    xheric00@fit.vutbr.cz                           *
 * Projekt: Implementace interpretu imperativnho jazyka IFJ08.              *
 * Popis:   Hlavikov sbor operci nad ADT zsobnk
 */
 
 
#ifndef _ZASOBNIK_H_
#define _ZASOBNIK_H_
#define KONIEC -1


#include "hash.h"
#include "scanner.h"
#include "error.h"
#include <stdlib.h>

typedef struct zasobnik_item
{
        tprvek *ptr;
	      int token;
        struct zasobnik_item *next;
} *tzasobnikitemPtr;

/*
 *  struktura zasobnika
 */
typedef struct zasobnik
{
  tzasobnikitemPtr act;
	tzasobnikitemPtr vrchol;
} tzasobnik;


void zasobnik_init(tzasobnik *zasobnik);
void zasobik_zrus(tzasobnik *zasobnik);
int zasobnik_prazdny(tzasobnik *zasobnik);
int zasobnik_toppop(tzasobnik *zasobnik, tprvek**ptr);
int zasobnik_vnorenie(tzasobnik *zasobnik);
void zasobnik_push(tzasobnik *zasobnik, int cislo, tprvek *ptr);

#endif /* _ZASOBNIK_H_ */
